<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__em__eeprom_8h" kind="file" language="C++">
    <compoundname>cy_em_eeprom.h</compoundname>
    <includes local="no">stddef.h</includes>
    <includes local="yes">cy_device_headers.h</includes>
    <includes local="yes">cy_syslib.h</includes>
    <includes local="yes">cy_flash.h</includes>
    <includedby local="yes" refid="cy__em__eeprom_8c">cy_em_eeprom.c</includedby>
    <incdepgraph>
      <node id="7">
        <label>cy_syslib.h</label>
      </node>
      <node id="5">
        <label>stddef.h</label>
      </node>
      <node id="4">
        <label>cy_em_eeprom.h</label>
        <link refid="cy__em__eeprom_8h" />
        <childnode refid="5" relation="include">
        </childnode>
        <childnode refid="6" relation="include">
        </childnode>
        <childnode refid="7" relation="include">
        </childnode>
        <childnode refid="8" relation="include">
        </childnode>
      </node>
      <node id="8">
        <label>cy_flash.h</label>
      </node>
      <node id="6">
        <label>cy_device_headers.h</label>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structcy__stc__eeprom__config__t">cy_stc_eeprom_config_t</innerclass>
    <innerclass prot="public" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</innerclass>
      <sectiondef kind="define">
      <memberdef id="group__group__em__eeprom__macros_1gab0bf9bfb139a2298c6178b8e801c9614" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_MW_VERSION_MAJOR</name>
        <initializer>(2)</initializer>
        <briefdescription>
<para>Library major version. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="764" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="764" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1ga15ba88c4930fbc76af0863e9aa2c7ece" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_MW_VERSION_MINOR</name>
        <initializer>(0)</initializer>
        <briefdescription>
<para>Library minor version. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="767" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="767" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1ga2ad924c909a5cf17ed0a6b9e78b674b6" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_ID</name>
        <initializer>(CY_PDL_DRV_ID(0x1BuL))</initializer>
        <briefdescription>
<para>Em_EEPROM PDL ID. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="770" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="770" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_ID_ERROR</name>
        <initializer>((uint32_t)(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga2ad924c909a5cf17ed0a6b9e78b674b6">CY_EM_EEPROM_ID</ref> | CY_PDL_STATUS_ERROR))</initializer>
        <briefdescription>
<para>A prefix for Em_EEPROM function error return-values. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="773" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="773" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_FLASH_SIZEOF_ROW</name>
        <initializer>(CY_FLASH_SIZEOF_ROW)</initializer>
        <briefdescription>
<para>Defines the size of a flash row. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="776" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="776" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1gad3f22fd154e4be09faa0c3bf6de4c95e" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_EEPROM_DATA_LEN</name>
        <param><defname>simpleMode</defname></param>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref> / (2uL - (simpleMode)))</initializer>
        <briefdescription>
<para>Defines the maximum data length that can be stored in one flash row. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="779" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="779" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1ga52c814cb9edacaf616d9e467480220b1" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_GET_NUM_ROWS_IN_EEPROM</name>
        <param><defname>dataSize</defname></param>
        <param><defname>simpleMode</defname></param>
        <initializer>((((dataSize) - 1uL) / (CY_EM_EEPROM_EEPROM_DATA_LEN(simpleMode))) + 1uL)</initializer>
        <briefdescription>
<para>The number of flash rows required to create an Em_EEPROM of dataSize. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="783" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="783" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1ga1362fc2cdec8a779fb71f9db031f8df5" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_GET_NUM_DATA</name>
        <param><defname>dataSize</defname></param>
        <param><defname>simpleMode</defname></param>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga52c814cb9edacaf616d9e467480220b1">CY_EM_EEPROM_GET_NUM_ROWS_IN_EEPROM</ref>(dataSize, simpleMode) * \
                <ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref>)</initializer>
        <briefdescription>
<para>Defines the maximum number of byte that can be stored in the Em_EEPROM storage. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="787" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="787" />
      </memberdef>
      <memberdef id="group__group__em__eeprom__macros_1gaedb7ebd5ea6efe79173c6582003420fb" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_GET_PHYSICAL_SIZE</name>
        <param><defname>dataSize</defname></param>
        <param><defname>simpleMode</defname></param>
        <param><defname>wearLeveling</defname></param>
        <param><defname>redundantCopy</defname></param>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1362fc2cdec8a779fb71f9db031f8df5">CY_EM_EEPROM_GET_NUM_DATA</ref>(dataSize, simpleMode) * \
                ((((1uL - (simpleMode)) * (wearLeveling)) * ((redundantCopy) + 1uL)) + (simpleMode)))</initializer>
        <briefdescription>
<para>Returns the size of flash allocated for Em_EEPROM including wear leveling and a redundant copy overhead. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="792" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="792" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ad0cc2d206d0b89b6d32285bb17b371c4" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_FLASH_BASE_ADDR</name>
        <initializer>(CY_FLASH_BASE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="984" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="984" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a16262080b9460b1cd11943e2505ea322" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_FLASH_SIZE</name>
        <initializer>(CY_FLASH_SIZE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="985" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="985" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a8efbabac3cc3deca0601108763a93d96" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_EM_EEPROM_BASE_ADDR</name>
        <initializer>(CY_EM_EEPROM_BASE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="986" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="986" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1abe43eda35ab340bfc45e5fd7183838ce" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_EM_EEPROM_SIZE</name>
        <initializer>(CY_EM_EEPROM_SIZE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="987" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="987" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ae14bc9ed4b93327890902abd338610fd" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_EM_EEPROM_END_ADDR</name>
        <initializer>(CY_EM_EEPROM_EM_EEPROM_BASE_ADDR + CY_EM_EEPROM_EM_EEPROM_SIZE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="988" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="988" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a3fb33117e64bd54b5c93e42198c99874" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_FLASH_END_ADDR</name>
        <initializer>(CY_EM_EEPROM_FLASH_BASE_ADDR + CY_EM_EEPROM_FLASH_SIZE)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="990" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="990" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1add5bc8888d9a7985b682fa764ee12299" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_IS_IN_FLASH_RANGE</name>
        <param><defname>startAddr</defname></param>
        <param><defname>endAddr</defname></param>
        <initializer>((((startAddr) &gt; CY_EM_EEPROM_FLASH_BASE_ADDR) &amp;&amp; ((endAddr) &lt;= CY_EM_EEPROM_FLASH_END_ADDR)) || \
                     (((startAddr) &gt;= CY_EM_EEPROM_EM_EEPROM_BASE_ADDR) &amp;&amp; ((endAddr) &lt;= CY_EM_EEPROM_EM_EEPROM_END_ADDR)))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="993" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="993" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a5bf5c9a6fd663ee6ee9dc42f299912fd" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_DATA_LEN</name>
        <initializer>((<ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref> / 2u) - 16u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="998" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="998" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1aefa07284ccfbb22eaa88e635f35b6503" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_IS_ADDRESES_CROSSING</name>
        <param><defname>startAddr1</defname></param>
        <param><defname>endAddr1</defname></param>
        <param><defname>startAddr2</defname></param>
        <param><defname>endAddr2</defname></param>
        <initializer>(((startAddr1) &gt; (startAddr2)) ? (((startAddr1) &gt;= (endAddr2)) ? (0u) : (1u) ) : \
                                    (((startAddr2) &gt;= (endAddr1)) ? (0u) : (1u)))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1007" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1004" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1aefa07284ccfbb22eaa88e635f35b6503" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_IS_ADDRESES_CROSSING</name>
        <param><defname>startAddr1</defname></param>
        <param><defname>endAddr1</defname></param>
        <param><defname>startAddr2</defname></param>
        <param><defname>endAddr2</defname></param>
        <initializer>(((startAddr1) &gt; (startAddr2)) ? (((startAddr1) &gt;= (endAddr2)) ? (0u) : (1u) ) : \
                                    (((startAddr2) &gt;= (endAddr1)) ? (0u) : (1u)))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1007" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1007" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a583e7ce89347000470429487c56636f9" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_IS_ADDR_IN_ROW_RANGE</name>
        <param><defname>addr</defname></param>
        <param><defname>rowNum</defname></param>
        <initializer>(((addr) &lt; ((rowNum) * (<ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref> / 2u))) ? (0u) : \
                                    (((addr) &gt; ((((rowNum) + 1u) * (CY_EM_EEPROM_FLASH_SIZEOF_ROW / 2u)) - 1u)) ? \
                                    (0u) : (1u)))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1015" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1015" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ae54482a6ff788bd6cbc834436df348aa" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_CRC8_POLYNOM</name>
        <initializer>((uint8_t)(0x31u))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1021" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1021" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1af03ab8a40d756470da0eef19c98b4a8f" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_CRC8_POLYNOM_LEN</name>
        <initializer>(8u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1022" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1022" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1aefd34c635027056d306fd7755bcd5180" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_CRC8_SEED</name>
        <initializer>(0xFFu)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1023" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1023" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ac5d9461063ffa2753f2a05aa46d2edd0" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_CRC8_XOR_VAL</name>
        <initializer>((uint8_t) (0x80u))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1024" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1024" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a798c8b926fac2a57f8c68c16c00b4a75" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_CALCULATE_CRC8</name>
        <param><defname>crc</defname></param>
        <initializer>((CY_EM_EEPROM_CRC8_XOR_VAL == ((crc) &amp; CY_EM_EEPROM_CRC8_XOR_VAL)) ? \
                  ((uint8_t)(((uint8_t)((uint8_t)((crc) &lt;&lt; 1u))) ^ CY_EM_EEPROM_CRC8_POLYNOM)) : ((uint8_t)((crc) &lt;&lt; 1u)))</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1026" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1026" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a416d1dac4f2eac6d7987b419548e92b1" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HISTORIC_DATA_OFFSET_U32</name>
        <initializer>((<ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref> / 2u) / 4u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1031" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1031" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ac6bad351cff68bb63cf8ad46e5381bdc" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_CHECKSUM_OFFSET_U32</name>
        <initializer>(0u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1032" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1032" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a9a6f848f1ef2a2fe4c6e76140ee27046" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_SEQ_NUM_OFFSET_U32</name>
        <initializer>(1u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1033" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1033" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ac81e812b65275ea608c0565dd22ad834" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_ADDR_OFFSET_U32</name>
        <initializer>(2u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1034" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1034" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a900ea6c03672ea4113fbf677b973c70a" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_LEN_OFFSET_U32</name>
        <initializer>(3u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1035" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1035" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a6fd96c8091fd3bb9efa60ddabf61301c" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_DATA_OFFSET_U32</name>
        <initializer>(4u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1036" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1036" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a04f6f824c47198f2b5cbfc17d911698b" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_FLASH_SIZEOF_ROW_U32</name>
        <initializer>(CY_FLASH_SIZEOF_ROW / 4u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1037" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1037" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a317e135bc74898fdb0a7795c5871cb2b" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HISTORIC_DATA_OFFSET</name>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1gafcfe832fb11038d572c8616962459e51">CY_EM_EEPROM_FLASH_SIZEOF_ROW</ref> / 2u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1040" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1040" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ad590863d4751a8b6cc1a0eb1a9a47334" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_CHECKSUM_OFFSET</name>
        <initializer>(0u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1041" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1041" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a2603693bf6c0fd79fd9dcb75327dc401" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_ADDR_OFFSET</name>
        <initializer>(8u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1042" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1042" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a719a0d38677efe5fa486d36268b2ee0c" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_LEN_OFFSET</name>
        <initializer>(12u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1043" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1043" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ac317406981dae965c686098aaca33828" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_HEADER_DATA_OFFSET</name>
        <initializer>(16u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1044" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1044" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1ad5986d0a408ca4316fecec63fd214fd8" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_U32</name>
        <initializer>(4u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1046" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1046" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a2025a55f2ec50436f438637a50af2f83" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_MAX_WEAR_LEVELING_FACTOR</name>
        <initializer>(10u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1049" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1049" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1aedd4a90a25a2696c8a8d8e43a654fb07" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_MAX_WRITE_DURATION_MS</name>
        <initializer>(50u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1052" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1052" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a81e0cc390220f532a2a7b5808859af84" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_VERSION_MAJOR</name>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1gab0bf9bfb139a2298c6178b8e801c9614">CY_EM_EEPROM_MW_VERSION_MAJOR</ref>)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1058" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1058" />
      </memberdef>
      <memberdef id="cy__em__eeprom_8h_1a4a33bdbbe5b227c59c359e13009f34a4" kind="define" prot="public" static="no">
        <name>CY_EM_EEPROM_VERSION_MINOR</name>
        <initializer>(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga15ba88c4930fbc76af0863e9aa2c7ece">CY_EM_EEPROM_MW_VERSION_MINOR</ref>)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="1059" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="1059" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="enum">
      <memberdef id="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2" kind="enum" prot="public" static="no">
        <name>cy_en_em_eeprom_status_t</name>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a76c897909d04df4dcbe9a901aa3a0fde" prot="public">
          <name>CY_EM_EEPROM_SUCCESS</name>
          <initializer>= 0x00uL</initializer>
          <briefdescription>
<para>The operation executed successfully. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a3a60e8bda0d0f453015522f1aa761956" prot="public">
          <name>CY_EM_EEPROM_BAD_PARAM</name>
          <initializer>= (CY_EM_EEPROM_ID_ERROR + 1uL)</initializer>
          <briefdescription>
<para>The function input parameter is invalid. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a303428d654a6313bfac66e56d7e3dd4d" prot="public">
          <name>CY_EM_EEPROM_BAD_CHECKSUM</name>
          <initializer>= (CY_EM_EEPROM_ID_ERROR + 2uL)</initializer>
          <briefdescription>
<para>The data in Em_EEPROM is corrupted. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a16252cb6d3b9e7318d4e4935005e7f59" prot="public">
          <name>CY_EM_EEPROM_BAD_DATA</name>
          <initializer>= (CY_EM_EEPROM_ID_ERROR + 3uL)</initializer>
          <briefdescription>
<para>The provided configuration is invalid or placing Em_EEPROM in flash failed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a76c360c7a3688c44efd2d5ab46814cd3" prot="public">
          <name>CY_EM_EEPROM_WRITE_FAIL</name>
          <initializer>= (CY_EM_EEPROM_ID_ERROR + 4uL)</initializer>
          <briefdescription>
<para>Write to Em_EEPROM failed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a88d2e935967ca619987c78a194bbca5e" prot="public">
          <name>CY_EM_EEPROM_REDUNDANT_COPY_USED</name>
          <initializer>= (CY_EM_EEPROM_ID_ERROR + 5uL)</initializer>
          <briefdescription>
<para>When redundant copy is enabled and one of the copies has bad CRC and other one valid CRC. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cy_en_em_eeprom_status_t: </bold><linebreak />The Em_EEPROM return enumeration type.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="942" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" bodystart="928" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="929" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__em__eeprom__functions_1gab9f608d788f1a854b10c652c3bb00fdd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref></type>
        <definition>cy_en_em_eeprom_status_t Cy_Em_EEPROM_Init</definition>
        <argsstring>(const cy_stc_eeprom_config_t *config, cy_stc_eeprom_context_t *context)</argsstring>
        <name>Cy_Em_EEPROM_Init</name>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__eeprom__config__t">cy_stc_eeprom_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Initializes the Emulated EEPROM library by filling the context structure. </para>        </briefdescription>
        <detaileddescription>
<para>This function is called by the application program prior to calling any other function of the Em_EEPROM middleware.</para><para>Do not modify the context structure after it is filled with this function. Modification of the context structure may cause unexpected behavior of the Cy_Em_EEPROM functions that rely on this context structure.</para><para>This function does the following:<orderedlist>
<listitem><para>Checks the provided configuration for correctness.</para></listitem><listitem><para>Copies the provided configuration into the context structure.</para></listitem></orderedlist>
</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the configuration structure. See <ref kindref="compound" refid="structcy__stc__eeprom__config__t">cy_stc_eeprom_config_t</ref>.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the Em_EEPROM context structure to be filled by the function. See <ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the status of the operation <ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref> :<itemizedlist>
<listitem><para>CY_EM_EEPROM_SUCCESS - The operation is successfully completed.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_PARAM - The input parameter is invalid.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_DATA - The configuration is incorrect. </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="153" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.c" bodystart="119" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="954" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__em__eeprom__functions_1ga9e14084e3054f6f147004d2914f9216d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref></type>
        <definition>cy_en_em_eeprom_status_t Cy_Em_EEPROM_Read</definition>
        <argsstring>(uint32_t addr, void *eepromData, uint32_t size, cy_stc_eeprom_context_t *context)</argsstring>
        <name>Cy_Em_EEPROM_Read</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>eepromData</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Reads data from a specified location. </para>        </briefdescription>
        <detaileddescription>
<para>This function takes a logical Em_EEPROM address, converts it to an actual physical address where data is stored and returns the data to the user.</para><para>This function uses a buffer of the flash row size to perform the read operation. For the size of the row, refer to the specific PSoC device datasheet.</para><para>There are restrictions on using the read-while-write (RWW) feature for EEPROM emulation. There are also multiple constraints for blocking and nonblocking flash operations, relating to interrupts, power modes, IPC usage, etc. Refer to the "Flash (Flash System Routine)" section of the PSoC 6 Peripheral Driver Library (psoc6pdl) API Reference Manual.<linebreak />
</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The logical start address in the Em_EEPROM storage to start reading data from.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>eepromData</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a user array to write data to.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>The amount of data to read in bytes.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the Em_EEPROM context structure <ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the status of the operation <ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref> :<itemizedlist>
<listitem><para>CY_EM_EEPROM_SUCCESS - The operation is successfully completed.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_CHECKSUM - One of the row the data read from contains bad checksum.</para></listitem><listitem><para>CY_EM_EEPROM_REDUNDANT_COPY_USED - Some data were read from redundant copy.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_PARAM - The function input parameter is invalid. </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="216" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.c" bodystart="194" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="958" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__em__eeprom__functions_1gaa792ff05d2b6ee71b44f1faeb2b68886" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref></type>
        <definition>cy_en_em_eeprom_status_t Cy_Em_EEPROM_Write</definition>
        <argsstring>(uint32_t addr, const void *eepromData, uint32_t size, cy_stc_eeprom_context_t *context)</argsstring>
        <name>Cy_Em_EEPROM_Write</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>eepromData</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Writes data to a specified location. </para>        </briefdescription>
        <detaileddescription>
<para>This function takes the logical Em_EEPROM address and converts it to an actual physical address and writes data there. If wear leveling is enabled, the writing process uses the wear leveling techniques.</para><para>This is a blocking function and it does not return until the write operation is completed. The user's application program cannot enter Hibernate mode until the write is completed. The write operation is allowed in CPU Sleep and System Deep Sleep modes. Do not reset your device during the flash operation, including the XRES pin, a software reset, and watchdog reset sources. Also, configure low-voltage detect circuits to generate an interrupt instead of a reset. Otherwise, portions of flash may undergo unexpected changes.</para><para>This function uses a buffer of the flash row size to perform the write operation. For the size of the row, refer to the specific PSoC device datasheet.</para><para>If the blocking write option is used, and write or erase operations are performed by CM4, the user's code on CM0P and CM4 is blocked until the operations are completed. If the operations are performed by CM0P, the user's code on CM4 is not blocked and the user code's on CM0P is blocked until the operation is completed. Plan your task allocation accordingly.</para><para>There are restrictions on using the read-while-write (RWW) feature for EEPROM emulation. There are also multiple constraints for blocking and nonblocking flash operations, relating to interrupts, Power modes, IPC usage, etc. Refer to the "Flash (Flash System Routine)" section of the PSoC 6 Peripheral Driver Library (psoc6pdl) API Reference Manual.<linebreak />
</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The logical start address in the Em_EEPROM storage to start writing data to.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>eepromData</parametername>
</parameternamelist>
<parameterdescription>
<para>Data to write to Em_EEPROM.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>The amount of data to write to Em_EEPROM in bytes.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the Em_EEPROM context structure <ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the status of the operation <ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref> :<itemizedlist>
<listitem><para>CY_EM_EEPROM_SUCCESS - The operation is successfully completed.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_CHECKSUM - One of the row the data read from contains bad checksum.</para></listitem><listitem><para>CY_EM_EEPROM_REDUNDANT_COPY_USED - Some data were read from redundant copy.</para></listitem><listitem><para>CY_EM_EEPROM_WRITE_FAIL - The write operation is failed.</para></listitem><listitem><para>CY_EM_EEPROM_BAD_PARAM - The function input parameter is invalid. </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="528" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.c" bodystart="507" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="964" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__em__eeprom__functions_1gad61dbc3c01d2bbf96e0c0d5b6d2e0b61" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref></type>
        <definition>cy_en_em_eeprom_status_t Cy_Em_EEPROM_Erase</definition>
        <argsstring>(cy_stc_eeprom_context_t *context)</argsstring>
        <name>Cy_Em_EEPROM_Erase</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>This function erases the entire content of Em_EEPROM. </para>        </briefdescription>
        <detaileddescription>
<para>Erased values are all zeros.</para><para>In the <ref kindref="member" refid="index_1section_em_eeprom_mode_simple">Simple Mode</ref> the function just erases the entire content of Em_EEPROM.</para><para>When Simple Mode is disabled, the function first performs one write operation to keep the number of writes completed so far and then erases all rest content of Em_EEPROM memory. So, the <ref kindref="member" refid="group__group__em__eeprom__functions_1gad7fb39640526ce706a7867d955d2b275">Cy_Em_EEPROM_NumWrites()</ref> function returns the correct value. Refer to the <ref kindref="member" refid="group__group__em__eeprom__functions_1gaa792ff05d2b6ee71b44f1faeb2b68886">Cy_Em_EEPROM_Write()</ref> function for the side effect of the write operation. If the write operation is failed then corresponding status is returned and no erase operation is executed.</para><para>This function uses a buffer of the flash row size to perform the erase operation. For the size of the row, refer to the specific PSoC device datasheet.</para><para>This is a blocking function and it does not return until the erase operation is completed. The user's application program cannot enter Hibernate mode until the write is completed. The write operation is allowed in CPU Sleep and System Deep Sleep modes. Do not reset your device during the flash operation, including the XRES pin, a software reset, and watchdog reset sources. Also, configure low-voltage detect circuits to generate an interrupt instead of a reset. Otherwise, portions of flash may undergo unexpected changes.</para><para>If the blocking write option is used, and write or erase operations are performed by CM4, the user's code on CM0P and CM4 is blocked until the operations are completed. If the operations are performed by CM0P, the user's code on CM4 is not blocked and the user code's on CM0P is blocked until the operation is completed. Plan your task allocation accordingly.</para><para>There are restrictions on using the read-while-write (RWW) feature for EEPROM emulation. There are also multiple constraints for blocking and nonblocking flash operations, relating to interrupts, power mode, IPC usage, etc. Refer to the "Flash (Flash System Routine)" section of the PSoC 6 Peripheral Driver Library (psoc6pdl) API Reference Manual.<linebreak />
 Also, refer to the <ref kindref="member" refid="index_1section_em_eeprom_miscellaneous">Limitations and Restrictions</ref> section for the different Em_EEPROM middleware restrictions and limitations.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the Em_EEPROM context structure <ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the status of the operation <ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref> :<itemizedlist>
<listitem><para>CY_EM_EEPROM_SUCCESS - The operation is successfully completed.</para></listitem><listitem><para>CY_EM_EEPROM_WRITE_FAIL - The either Write or Erase operation is failed. </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="845" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.c" bodystart="767" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="970" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__em__eeprom__functions_1gad7fb39640526ce706a7867d955d2b275" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t Cy_Em_EEPROM_NumWrites</definition>
        <argsstring>(cy_stc_eeprom_context_t *context)</argsstring>
        <name>Cy_Em_EEPROM_NumWrites</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Returns the number of the Em_EEPROM Writes completed so far. </para>        </briefdescription>
        <detaileddescription>
<para>This function returns zero in the <ref kindref="member" refid="index_1section_em_eeprom_mode_simple">Simple Mode</ref> since the number of writes is not available in this case.</para><para>Use this function to monitor the flash memory endurance. The higher the value, the less the flash memory endurance. Refer to the datasheet write endurance spec to determine the maximum number of write cycles. If the Wear Leveling feature is enabled, then the maximum of write cycles is increased by <ref kindref="member" refid="structcy__stc__eeprom__config__t_1a19b32e2183e33f98f02e15e2bce4f207">cy_stc_eeprom_config_t::wearLevelingFactor</ref>.</para><para>The returned number does not include the number of writes into the redundant copy if enabled.</para><para>This function does the following:<orderedlist>
<listitem><para>Returns the number of writes stored in the the last written row if the checksum of the row is correct.</para></listitem><listitem><para>If the checksum of the last written row is invalid and the redundant copy feature is enabled, then the row checksum of the redundant copy is verified for correctness and corresponding number of writes is returned.</para></listitem><listitem><para>If the checksum of the last written row is incorrect, then a special algorithm of searching the last written is executed and a corresponding number of writes is reported.</para></listitem><listitem><para>If the algorithm is unable to find the last written row (there is no row with the correct checksum), then zero is returned.</para></listitem></orderedlist>
</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the Em_EEPROM context structure <ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The number of writes performed to the Em_EEPROM. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="893" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.c" bodystart="886" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" line="973" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="2"><highlight class="comment">*<sp />\file<sp />cy_em_eeprom.h</highlight></codeline>
<codeline lineno="3"><highlight class="comment">*<sp />\version<sp />2.0</highlight></codeline>
<codeline lineno="4"><highlight class="comment">*</highlight></codeline>
<codeline lineno="5"><highlight class="comment">*<sp />\brief</highlight></codeline>
<codeline lineno="6"><highlight class="comment">*<sp />This<sp />file<sp />provides<sp />the<sp />function<sp />prototypes<sp />and<sp />constants<sp />for<sp />the</highlight></codeline>
<codeline lineno="7"><highlight class="comment">*<sp />Emulated<sp />EEPROM<sp />middleware<sp />library.</highlight></codeline>
<codeline lineno="8"><highlight class="comment">*</highlight></codeline>
<codeline lineno="9"><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline lineno="10"><highlight class="comment">*<sp />\copyright</highlight></codeline>
<codeline lineno="11"><highlight class="comment">*<sp />Copyright<sp />2017-2019,<sp />Cypress<sp />Semiconductor<sp />Corporation.<sp /><sp />All<sp />rights<sp />reserved.</highlight></codeline>
<codeline lineno="12"><highlight class="comment">*<sp />You<sp />may<sp />use<sp />this<sp />file<sp />only<sp />in<sp />accordance<sp />with<sp />the<sp />license,<sp />terms,<sp />conditions,</highlight></codeline>
<codeline lineno="13"><highlight class="comment">*<sp />disclaimers,<sp />and<sp />limitations<sp />in<sp />the<sp />end<sp />user<sp />license<sp />agreement<sp />accompanying</highlight></codeline>
<codeline lineno="14"><highlight class="comment">*<sp />the<sp />software<sp />package<sp />with<sp />which<sp />this<sp />file<sp />was<sp />provided.</highlight></codeline>
<codeline lineno="15"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="16"><highlight class="normal" /></codeline>
<codeline lineno="742"><highlight class="preprocessor">#if<sp />!defined(CY_EM_EEPROM_H)</highlight><highlight class="normal" /></codeline>
<codeline lineno="743"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_H</highlight><highlight class="normal" /></codeline>
<codeline lineno="744"><highlight class="normal" /></codeline>
<codeline lineno="745"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stddef.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="746"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_device_headers.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="747"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="748"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_flash.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="749"><highlight class="normal" /></codeline>
<codeline lineno="750"><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />C<sp />binding<sp />of<sp />definitions<sp />if<sp />building<sp />with<sp />the<sp />C++<sp />compiler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="751"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="752"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="753"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />__cplusplus<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="754"><highlight class="normal" /></codeline>
<codeline lineno="755"><highlight class="normal" /></codeline>
<codeline lineno="756"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="757"><highlight class="comment">*<sp />API<sp />Constants</highlight></codeline>
<codeline lineno="758"><highlight class="comment">*******************************************************************************/</highlight></codeline>
<codeline lineno="764"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_MW_VERSION_MAJOR<sp /><sp /><sp /><sp /><sp /><sp /><sp />(2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="765"><highlight class="normal" /></codeline>
<codeline lineno="767"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_MW_VERSION_MINOR<sp /><sp /><sp /><sp /><sp /><sp /><sp />(0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="768"><highlight class="normal" /></codeline>
<codeline lineno="770"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_ID<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_PDL_DRV_ID(0x1BuL))</highlight><highlight class="normal" /></codeline>
<codeline lineno="771"><highlight class="normal" /></codeline>
<codeline lineno="773"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_ID_ERROR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint32_t)(CY_EM_EEPROM_ID<sp />|<sp />CY_PDL_STATUS_ERROR))</highlight><highlight class="normal" /></codeline>
<codeline lineno="774"><highlight class="normal" /></codeline>
<codeline lineno="776"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_FLASH_SIZEOF_ROW)</highlight><highlight class="normal" /></codeline>
<codeline lineno="777"><highlight class="normal" /></codeline>
<codeline lineno="779"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_EEPROM_DATA_LEN(simpleMode)<sp />\</highlight></codeline>
<codeline lineno="780"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />(2uL<sp />-<sp />(simpleMode)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="781"><highlight class="normal" /></codeline>
<codeline lineno="783"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_GET_NUM_ROWS_IN_EEPROM(dataSize,<sp />simpleMode)<sp />\</highlight></codeline>
<codeline lineno="784"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((((dataSize)<sp />-<sp />1uL)<sp />/<sp />(CY_EM_EEPROM_EEPROM_DATA_LEN(simpleMode)))<sp />+<sp />1uL)</highlight><highlight class="normal" /></codeline>
<codeline lineno="785"><highlight class="normal" /></codeline>
<codeline lineno="787"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_GET_NUM_DATA(dataSize,<sp />simpleMode)<sp />\</highlight></codeline>
<codeline lineno="788"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_GET_NUM_ROWS_IN_EEPROM(dataSize,<sp />simpleMode)<sp />*<sp />\</highlight></codeline>
<codeline lineno="789"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_EM_EEPROM_FLASH_SIZEOF_ROW)</highlight><highlight class="normal" /></codeline>
<codeline lineno="790"><highlight class="normal" /></codeline>
<codeline lineno="792"><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_GET_PHYSICAL_SIZE(dataSize,<sp />simpleMode,<sp />wearLeveling,<sp />redundantCopy)<sp />\</highlight></codeline>
<codeline lineno="793"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_GET_NUM_DATA(dataSize,<sp />simpleMode)<sp />*<sp />\</highlight></codeline>
<codeline lineno="794"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((((1uL<sp />-<sp />(simpleMode))<sp />*<sp />(wearLeveling))<sp />*<sp />((redundantCopy)<sp />+<sp />1uL))<sp />+<sp />(simpleMode)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="795"><highlight class="normal" /></codeline>
<codeline lineno="799"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="800"><highlight class="comment">*<sp />Data<sp />Structure<sp />definitions</highlight></codeline>
<codeline lineno="801"><highlight class="comment">*******************************************************************************/</highlight></codeline>
<codeline lineno="808" refid="structcy__stc__eeprom__config__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="809"><highlight class="normal">{</highlight></codeline>
<codeline lineno="823"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />eepromSize;</highlight></codeline>
<codeline lineno="824"><highlight class="normal" /></codeline>
<codeline lineno="836"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />simpleMode;</highlight></codeline>
<codeline lineno="837"><highlight class="normal" /></codeline>
<codeline lineno="845"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />wearLevelingFactor;</highlight></codeline>
<codeline lineno="846"><highlight class="normal" /></codeline>
<codeline lineno="854"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />redundantCopy;</highlight></codeline>
<codeline lineno="855"><highlight class="normal" /></codeline>
<codeline lineno="863"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />blockingWrite;</highlight></codeline>
<codeline lineno="864"><highlight class="normal" /></codeline>
<codeline lineno="871"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />userFlashStartAddr;</highlight></codeline>
<codeline lineno="872"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__eeprom__config__t">cy_stc_eeprom_config_t</ref>;</highlight></codeline>
<codeline lineno="873"><highlight class="normal" /></codeline>
<codeline lineno="874"><highlight class="normal" /></codeline>
<codeline lineno="881" refid="structcy__stc__eeprom__context__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="882"><highlight class="normal">{</highlight></codeline>
<codeline lineno="886"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />numberOfRows;</highlight></codeline>
<codeline lineno="887"><highlight class="normal" /></codeline>
<codeline lineno="889"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />eepromSize;</highlight></codeline>
<codeline lineno="890"><highlight class="normal" /></codeline>
<codeline lineno="892"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />wearLevelingFactor;</highlight></codeline>
<codeline lineno="893"><highlight class="normal" /></codeline>
<codeline lineno="895"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />userFlashStartAddr;</highlight></codeline>
<codeline lineno="896"><highlight class="normal" /></codeline>
<codeline lineno="898"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />byteInRow;</highlight></codeline>
<codeline lineno="899"><highlight class="normal" /></codeline>
<codeline lineno="901"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />simpleMode;</highlight></codeline>
<codeline lineno="902"><highlight class="normal" /></codeline>
<codeline lineno="904"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*<sp />ptrLastWrittenRow;</highlight></codeline>
<codeline lineno="905"><highlight class="normal" /></codeline>
<codeline lineno="907"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />redundantCopy;</highlight></codeline>
<codeline lineno="908"><highlight class="normal" /></codeline>
<codeline lineno="912"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />blockingWrite;</highlight></codeline>
<codeline lineno="913"><highlight class="normal" /></codeline>
<codeline lineno="914"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref>;</highlight></codeline>
<codeline lineno="915"><highlight class="normal" /></codeline>
<codeline lineno="918"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="919"><highlight class="comment">*<sp />Enumerated<sp />Types<sp />and<sp />Parameters</highlight></codeline>
<codeline lineno="920"><highlight class="comment">*******************************************************************************/</highlight></codeline>
<codeline lineno="928"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="929"><highlight class="normal">{</highlight></codeline>
<codeline lineno="931"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a76c897909d04df4dcbe9a901aa3a0fde">CY_EM_EEPROM_SUCCESS</ref><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0x00uL,</highlight></codeline>
<codeline lineno="933"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a3a60e8bda0d0f453015522f1aa761956">CY_EM_EEPROM_BAD_PARAM</ref><sp /><sp /><sp /><sp />=<sp />(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a">CY_EM_EEPROM_ID_ERROR</ref><sp />+<sp />1uL),</highlight></codeline>
<codeline lineno="935"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a303428d654a6313bfac66e56d7e3dd4d">CY_EM_EEPROM_BAD_CHECKSUM</ref><sp />=<sp />(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a">CY_EM_EEPROM_ID_ERROR</ref><sp />+<sp />2uL),</highlight></codeline>
<codeline lineno="937"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a16252cb6d3b9e7318d4e4935005e7f59">CY_EM_EEPROM_BAD_DATA</ref><sp /><sp /><sp /><sp /><sp />=<sp />(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a">CY_EM_EEPROM_ID_ERROR</ref><sp />+<sp />3uL),</highlight></codeline>
<codeline lineno="939"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a76c360c7a3688c44efd2d5ab46814cd3">CY_EM_EEPROM_WRITE_FAIL</ref><sp /><sp /><sp />=<sp />(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a">CY_EM_EEPROM_ID_ERROR</ref><sp />+<sp />4uL),</highlight></codeline>
<codeline lineno="941"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1gga00cb0e6ed68329cd7aba18e3a93e13d2a88d2e935967ca619987c78a194bbca5e">CY_EM_EEPROM_REDUNDANT_COPY_USED</ref><sp /><sp /><sp /><sp />=<sp />(<ref kindref="member" refid="group__group__em__eeprom__macros_1ga1bdd4ebbd18469d5f450b66a31bc649a">CY_EM_EEPROM_ID_ERROR</ref><sp />+<sp />5uL),</highlight></codeline>
<codeline lineno="942"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref>;</highlight></codeline>
<codeline lineno="943"><highlight class="normal" /></codeline>
<codeline lineno="947"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="948"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Function<sp />Prototypes</highlight></codeline>
<codeline lineno="949"><highlight class="comment">*******************************************************************************/</highlight></codeline>
<codeline lineno="954"><highlight class="normal"><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref><sp /><ref kindref="member" refid="group__group__em__eeprom__functions_1gab9f608d788f1a854b10c652c3bb00fdd">Cy_Em_EEPROM_Init</ref>(</highlight></codeline>
<codeline lineno="955"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__eeprom__config__t">cy_stc_eeprom_config_t</ref><sp />*<sp />config,</highlight></codeline>
<codeline lineno="956"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref><sp />*<sp />context);</highlight></codeline>
<codeline lineno="957"><highlight class="normal" /></codeline>
<codeline lineno="958"><highlight class="normal"><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref><sp /><ref kindref="member" refid="group__group__em__eeprom__functions_1ga9e14084e3054f6f147004d2914f9216d">Cy_Em_EEPROM_Read</ref>(</highlight></codeline>
<codeline lineno="959"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />addr,</highlight></codeline>
<codeline lineno="960"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*<sp />eepromData,</highlight></codeline>
<codeline lineno="961"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />size,</highlight></codeline>
<codeline lineno="962"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref><sp />*<sp />context);</highlight></codeline>
<codeline lineno="963"><highlight class="normal" /></codeline>
<codeline lineno="964"><highlight class="normal"><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref><sp /><ref kindref="member" refid="group__group__em__eeprom__functions_1gaa792ff05d2b6ee71b44f1faeb2b68886">Cy_Em_EEPROM_Write</ref>(</highlight></codeline>
<codeline lineno="965"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />addr,</highlight></codeline>
<codeline lineno="966"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*<sp />eepromData,</highlight></codeline>
<codeline lineno="967"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />size,</highlight></codeline>
<codeline lineno="968"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref><sp />*<sp />context);</highlight></codeline>
<codeline lineno="969"><highlight class="normal" /></codeline>
<codeline lineno="970"><highlight class="normal"><ref kindref="member" refid="group__group__em__eeprom__enums_1ga00cb0e6ed68329cd7aba18e3a93e13d2">cy_en_em_eeprom_status_t</ref><sp /><ref kindref="member" refid="group__group__em__eeprom__functions_1gad61dbc3c01d2bbf96e0c0d5b6d2e0b61">Cy_Em_EEPROM_Erase</ref>(</highlight></codeline>
<codeline lineno="971"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref><sp />*<sp />context);</highlight></codeline>
<codeline lineno="972"><highlight class="normal" /></codeline>
<codeline lineno="973"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__em__eeprom__functions_1gad7fb39640526ce706a7867d955d2b275">Cy_Em_EEPROM_NumWrites</ref>(</highlight></codeline>
<codeline lineno="974"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__eeprom__context__t">cy_stc_eeprom_context_t</ref><sp />*<sp />context);</highlight></codeline>
<codeline lineno="975"><highlight class="normal" /></codeline>
<codeline lineno="979"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="980"><highlight class="comment">*<sp />Internal<sp />Macro<sp />Definitions</highlight></codeline>
<codeline lineno="981"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="982"><highlight class="normal" /></codeline>
<codeline lineno="983"><highlight class="normal" /><highlight class="comment">/*<sp />Device-specific<sp />flash<sp />constants<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="984"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_FLASH_BASE_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_FLASH_BASE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="985"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_FLASH_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_FLASH_SIZE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="986"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_EM_EEPROM_BASE_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_BASE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="987"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_EM_EEPROM_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_SIZE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="988"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_EM_EEPROM_END_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_EM_EEPROM_BASE_ADDR<sp />+<sp />CY_EM_EEPROM_EM_EEPROM_SIZE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="989"><highlight class="normal" /></codeline>
<codeline lineno="990"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_FLASH_END_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_FLASH_BASE_ADDR<sp />+<sp />CY_EM_EEPROM_FLASH_SIZE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="991"><highlight class="normal" /></codeline>
<codeline lineno="992"><highlight class="normal" /><highlight class="comment">/*<sp />Checks<sp />whether<sp />Em_EEPROM<sp />is<sp />in<sp />the<sp />flash<sp />range.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="993"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_IS_IN_FLASH_RANGE(startAddr,<sp />endAddr)<sp />\</highlight></codeline>
<codeline lineno="994"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((((startAddr)<sp />&gt;<sp />CY_EM_EEPROM_FLASH_BASE_ADDR)<sp />&amp;&amp;<sp />((endAddr)<sp />&lt;=<sp />CY_EM_EEPROM_FLASH_END_ADDR))<sp />||<sp />\</highlight></codeline>
<codeline lineno="995"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((startAddr)<sp />&gt;=<sp />CY_EM_EEPROM_EM_EEPROM_BASE_ADDR)<sp />&amp;&amp;<sp />((endAddr)<sp />&lt;=<sp />CY_EM_EEPROM_EM_EEPROM_END_ADDR)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="996"><highlight class="normal" /></codeline>
<codeline lineno="997"><highlight class="normal" /><highlight class="comment">/*<sp />Defines<sp />the<sp />length<sp />of<sp />data<sp />that<sp />can<sp />be<sp />stored<sp />in<sp />the<sp />Em_EEPROM<sp />header.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="998"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_DATA_LEN<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />2u)<sp />-<sp />16u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="999"><highlight class="normal" /></codeline>
<codeline lineno="1000"><highlight class="normal" /><highlight class="comment">/*</highlight></codeline>
<codeline lineno="1001"><highlight class="comment">*<sp />Checks<sp />whether<sp />the<sp />Em_EEPROM<sp />address<sp />locations<sp />from<sp />startAddr1<sp />to<sp />endAddr1</highlight></codeline>
<codeline lineno="1002"><highlight class="comment">*<sp />are<sp />crossed<sp />with<sp />the<sp />Em_EEPROM<sp />address<sp />locations<sp />from<sp />startAddr2<sp />to<sp />endAddr2.</highlight></codeline>
<codeline lineno="1003"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1004"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_IS_ADDRESES_CROSSING(startAddr1,<sp />endAddr1<sp />,<sp />startAddr2,<sp />endAddr2)<sp />\</highlight></codeline>
<codeline lineno="1005"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((startAddr1)<sp />&gt;<sp />(startAddr2))<sp />?<sp />(((startAddr1)<sp />&gt;=<sp />(endAddr2))<sp />?<sp />(0u)<sp />:<sp />(1u)<sp />)<sp />:<sp />\</highlight></codeline>
<codeline lineno="1006"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((startAddr2)<sp />&gt;=<sp />(endAddr1))<sp />?<sp />(0u)<sp />:<sp />(1u)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1007"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_IS_ADDRESES_CROSSING(startAddr1,<sp />endAddr1<sp />,<sp />startAddr2,<sp />endAddr2)<sp />\</highlight></codeline>
<codeline lineno="1008"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((startAddr1)<sp />&gt;<sp />(startAddr2))<sp />?<sp />(((startAddr1)<sp />&gt;=<sp />(endAddr2))<sp />?<sp />(0u)<sp />:<sp />(1u)<sp />)<sp />:<sp />\</highlight></codeline>
<codeline lineno="1009"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((startAddr2)<sp />&gt;=<sp />(endAddr1))<sp />?<sp />(0u)<sp />:<sp />(1u)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1010"><highlight class="normal" /></codeline>
<codeline lineno="1011"><highlight class="normal" /></codeline>
<codeline lineno="1012"><highlight class="normal" /><highlight class="comment">/*<sp />Checks<sp />whether<sp />the<sp />given<sp />address<sp />belongs<sp />to<sp />the<sp />Em_EEPROM<sp />address<sp />of<sp />the<sp />row</highlight></codeline>
<codeline lineno="1013"><highlight class="comment">*<sp />specified<sp />by<sp />rowNum.</highlight></codeline>
<codeline lineno="1014"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1015"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_IS_ADDR_IN_ROW_RANGE(addr,<sp />rowNum)<sp />\</highlight></codeline>
<codeline lineno="1016"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((addr)<sp />&lt;<sp />((rowNum)<sp />*<sp />(CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />2u)))<sp />?<sp />(0u)<sp />:<sp />\</highlight></codeline>
<codeline lineno="1017"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((addr)<sp />&gt;<sp />((((rowNum)<sp />+<sp />1u)<sp />*<sp />(CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />2u))<sp />-<sp />1u))<sp />?<sp />\</highlight></codeline>
<codeline lineno="1018"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0u)<sp />:<sp />(1u)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1019"><highlight class="normal" /></codeline>
<codeline lineno="1020"><highlight class="normal" /><highlight class="comment">/*<sp />CRC-8<sp />constants<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1021"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_CRC8_POLYNOM<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)(0x31u))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1022"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_CRC8_POLYNOM_LEN<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(8u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1023"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_CRC8_SEED<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0xFFu)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1024"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_CRC8_XOR_VAL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)<sp />(0x80u))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1025"><highlight class="normal" /></codeline>
<codeline lineno="1026"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_CALCULATE_CRC8(crc)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="1027"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((CY_EM_EEPROM_CRC8_XOR_VAL<sp />==<sp />((crc)<sp />&amp;<sp />CY_EM_EEPROM_CRC8_XOR_VAL))<sp />?<sp />\</highlight></codeline>
<codeline lineno="1028"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)(((uint8_t)((uint8_t)((crc)<sp />&lt;&lt;<sp />1u)))<sp />^<sp />CY_EM_EEPROM_CRC8_POLYNOM))<sp />:<sp />((uint8_t)((crc)<sp />&lt;&lt;<sp />1u)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="1029"><highlight class="normal" /></codeline>
<codeline lineno="1030"><highlight class="normal" /><highlight class="comment">/*<sp />Offsets<sp />for<sp />the<sp />32-bit<sp />RAM<sp />buffer<sp />addressing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1031"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HISTORIC_DATA_OFFSET_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp />((CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />2u)<sp />/<sp />4u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1032"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_CHECKSUM_OFFSET_U32<sp /><sp /><sp /><sp /><sp />(0u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1033"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_SEQ_NUM_OFFSET_U32<sp /><sp /><sp /><sp /><sp /><sp />(1u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1034"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_ADDR_OFFSET_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(2u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1035"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_LEN_OFFSET_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1036"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_DATA_OFFSET_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(4u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1037"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_FLASH_SIZEOF_ROW_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_FLASH_SIZEOF_ROW<sp />/<sp />4u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1038"><highlight class="normal" /></codeline>
<codeline lineno="1039"><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />same<sp />offsets<sp />as<sp />above<sp />used<sp />for<sp />direct<sp />memory<sp />addressing.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1040"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HISTORIC_DATA_OFFSET<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_FLASH_SIZEOF_ROW<sp />/<sp />2u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1041"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_CHECKSUM_OFFSET<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1042"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_ADDR_OFFSET<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(8u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1043"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_LEN_OFFSET<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(12u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1044"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_HEADER_DATA_OFFSET<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(16u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1045"><highlight class="normal" /></codeline>
<codeline lineno="1046"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_U32<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(4u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1047"><highlight class="normal" /></codeline>
<codeline lineno="1048"><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />maximum<sp />wear-leveling<sp />value.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1049"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_MAX_WEAR_LEVELING_FACTOR<sp /><sp /><sp /><sp /><sp /><sp /><sp />(10u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1050"><highlight class="normal" /></codeline>
<codeline lineno="1051"><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />maximum<sp />allowed<sp />flash<sp />row<sp />Write/Erase<sp />operation<sp />duration.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1052"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_MAX_WRITE_DURATION_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(50u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1053"><highlight class="normal" /></codeline>
<codeline lineno="1054"><highlight class="normal" /><highlight class="comment">/*</highlight></codeline>
<codeline lineno="1055"><highlight class="comment">*<sp />These<sp />defines<sp />are<sp />obsolete<sp />and<sp />kept<sp />for<sp />the<sp />backward<sp />compatibility<sp />only.</highlight></codeline>
<codeline lineno="1056"><highlight class="comment">*<sp />They<sp />will<sp />be<sp />removed<sp />in<sp />future<sp />versions.</highlight></codeline>
<codeline lineno="1057"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="1058"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_VERSION_MAJOR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_MW_VERSION_MAJOR)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1059"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_EM_EEPROM_VERSION_MINOR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_EM_EEPROM_MW_VERSION_MINOR)</highlight><highlight class="normal" /></codeline>
<codeline lineno="1060"><highlight class="normal" /></codeline>
<codeline lineno="1061"><highlight class="normal" /></codeline>
<codeline lineno="1062"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="1063"><highlight class="normal">}</highlight></codeline>
<codeline lineno="1064"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />__cplusplus<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="1065"><highlight class="normal" /></codeline>
<codeline lineno="1066"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_EM_EEPROM_H<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="1067"><highlight class="normal" /></codeline>
<codeline lineno="1068"><highlight class="normal" /></codeline>
<codeline lineno="1069"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-emeeprom/cy_em_eeprom.h" />
  </compounddef>
</doxygen>